<?php

namespace PushAlert\PushNotifications\Controller\Index;

class Atc extends \Magento\Framework\App\Action\Action
{
    private $cart;
    private $product;
    private $addToCart;
    private $session;
    private $response;
    private $request;
    private $formKey;
    private $cookieHandler;

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \PushAlert\PushNotifications\Api\Data\AddToCartInterface $addToCart,
        \Magento\Checkout\Model\Cart $cart,
        \Magento\Catalog\Model\Product $product,
        \Magento\Checkout\Model\Session $session,
        \Magento\Framework\App\Response\Http $response,
        \Magento\Framework\App\Request\Http $request,
        \Magento\Framework\Data\Form\FormKey $formKey,
        \PushAlert\PushNotifications\Cookie\CookieHandler $cookieHandler
    ) {
        $this->cart = $cart;
        $this->product = $product;
        $this->addToCart = $addToCart;
        $this->session = $session;
        $this->response = $response;
        $this->request = $request;
        $this->formKey = $formKey;
        $this->cookieHandler = $cookieHandler;
        parent::__construct($context);
    }

    public function execute()
    {
        try {
            $check_pushalert_mage = filter_input(INPUT_GET, 'pushalert_source');
            if (isset($check_pushalert_mage)) {
                $this->cookieHandler->set('pushalert_mage', $check_pushalert_mage, 86400 * 3);
                $_COOKIE['pushalert_mage'] = $check_pushalert_mage;
            }
            $id = $this->request->getParam('product-id');
            $qty = 1;
            $this->product->load($id);
            $this->cart->addProduct(
                $this->product,
                ['form_key' => $this->formKey->getFormKey(),
                'product' => $id, 'qty' => $qty]
            );
            $this->cart->save();
            $this->session->setCartWasUpdated(true);
            $this->response->setRedirect('checkout/cart/index')->sendResponse();
        } catch (\Exception $e) {
            $this->response->setRedirect('/')->sendResponse();
            return;
        }
    }
}
