<?php

namespace PushAlert\PushNotifications\Controller\Index;

use Magento\Framework\Controller\ResultFactory;

class Swjs extends \Magento\Framework\App\Action\Action
{

    /** @var \PushAlert\PushNotifications\Api\Data\ServiceWorkerInterface $serviceworker */
    private $serviceworker;

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \PushAlert\PushNotifications\Api\Data\ServiceWorkerInterface $serviceworker
    ) {
        parent::__construct($context);

        $this->serviceworker = $serviceworker;
    }

    /**
     * @inheritdoc
     */
    public function execute()
    {
        $outputData = $this->resultFactory->create(ResultFactory::TYPE_RAW);
        $this->serviceworker->populateSW();
        $config_id = $this->serviceworker->getData();
        if ($config_id != null) {
            $config_id = $config_id['config_id'];
            $swUrl = '';
            if ($config_id != '') {
                $swUrl = 'importScripts("https://cdn.pushalert.co/sw-' . $config_id . '.js");';
            } else {
                $swUrl = '';
            }
            return $outputData->setHeader('Content-Type', 'application/javascript')
                            ->setHeader('Service-Worker-Allowed', '/')->setContents($swUrl);
        }
    }
}
