<?php

namespace PushAlert\PushNotifications\Controller;

class Router implements \Magento\Framework\App\RouterInterface
{
    const SW_ENDPOINT = "sw.js";
    const ADD_TO_CART = "pa-add-to-cart";
	private $helper;
	
    /** @var \Magento\Framework\App\ActionFactory $actionFactory */
    private $actionFactory;

    public function __construct(
        \Magento\Framework\App\ActionFactory $actionFactory,
        \PushAlert\PushNotifications\Helper\PushAlertHelper $helper
    ) {
        $this->actionFactory = $actionFactory;
        $this->helper = $helper;
    }

    public function match(\Magento\Framework\App\RequestInterface $request)
    {
        if ($this->helper->isEnabled()) {
            if ($this->helper->isHTTPSEnabled() && trim($request->getPathInfo(), "/") == static::SW_ENDPOINT) {
                $request
                        ->setModuleName("pushnotifications")
                        ->setControllerName("index")
                        ->setActionName("swjs");
                return $this->actionFactory->create('Magento\Framework\App\Action\Forward');
            } elseif (trim($request->getPathInfo(), "/") == static::ADD_TO_CART) {
                $request
                        ->setModuleName("pushnotifications")
                        ->setControllerName("index")
                        ->setActionName("atc");
                return $this->actionFactory->create('Magento\Framework\App\Action\Forward');
            }
        }
        return null;
    }
}
