<?php

namespace PushAlert\PushNotifications\Model;

use Magento\Store\Model\ScopeInterface;

class ServiceWorker implements \PushAlert\PushNotifications\Api\Data\ServiceWorkerInterface
{
    /** @var \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig */
    private $scopeConfig;

    /** @var array $data */
    private $data;

    public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    ) {
        $this->scopeConfig = $scopeConfig;
        $this->data = [];
    }

    /**
     * @inheritdoc
     */
    public function getData()
    {
        return $this->data;
    }

    /**
     * Populate the Service Worker with the Config ID.
     *
     * @return $this
     */
    public function populateSW()
    {
        $config_id = $this->getConfig("config_id", "corepushalert/settings");
        if ($config_id!='') {
            $this->data['config_id'] = $config_id;
            return $this;
        }
        
        return null;
    }

    /**
     * Populate the Service Worker with value from System Configuration.
     *
     * @param      $key
     * @param      $config_path
     * @param bool $if_exists Only populate the value if it's not empty (default: false)
     *
     * @return $this
     */
    public function getConfig($key, $config_path, $if_exists = false)
    {
        $value = $this->scopeConfig->getValue($config_path, ScopeInterface::SCOPE_STORE);

        if (!$if_exists || !empty($value)) {
            return $value[$key];
        }
        return 0;
    }
}
